# Conotoxia Pay - Plugin for PrestaShop
The plugin adds Conotoxia Pay payment gateway for PrestaShop.

## Changelog
- 1.23.0 Added support for PrestaShop 1.7.7.3.
- 1.22.2 Closed support for PrestaShop 1.7.6
- 1.14.4 Error handling on the payment summary page has been improved.
- 1.14.0 Added possibility to generate public and private keys during configuration.
- 1.10.0 Added a list view of returns for a given payment, and a possibility to make partial refunds.
- 1.6.0 Added a possibility to hide the icon on the payment selection list.
- 0.6.1 Added a sandbox mode that allows you to make payments on a test environment.

## Requirements
* PrestaShop version 1.7.7+
* PHP version 7.1.26+
* PHP extensions:
  * curl
  * json
  * openssl
  * readline

## Installation
1. The plugin should be downloaded from the [Conotoxia.com](https://conotoxia.com/payments/for-developers) website.  
2. In PrestaShop administration panel go to `Modules section -> Module Manager` and select `Upload module`.
3. Choose the previously downloaded plugin - the installation will start automatically.

### Manual installation
1. The downloaded plugin should be unpacked into `/modules` directory.
2. In `Modules -> Catalogue` tab, select `ConotoxiaPay` and install the module.

## Configuration
The following guide implies that the Partner has completed the configuration of the account in the [merchant's panel](https://fx.conotoxia.com/merchant/).  

### Plugin configuration in PrestaShop
1. In `Modules -> Module Manager`, select `ConotoxiaPay` and then click `Configure`.
2. Enter the necessary data in the plugin configuration:
   - `Client id*` and `Client secret*` - access data can be generated [merchant's panel](https://fx.conotoxia.com/merchant/) (Access Data section)
   - `Point of sale identifier*` - identifier of the created point of sale from the [merchant's panel](https://fx.conotoxia.com/merchant/)
   - `Private key` - it is possible to generate a private key on the plugin configuration page. A public key is generated from the private key entered on the plugin configuration page. This key is automatically transferred to Conotoxia Pay upon saving the configuration. It is not necessary to enter the key in the merchant's panel. Additional instructions on how to generate keys can be found in the [documentation](https://conotoxia.com/developer/payments/online-shops#generating-a-public-key)
   - `Test mode` - it is possible to test the module on a test environment. In order to gain access to the test environment, you should go to the [conotoxia.com](https://conotoxia.com/contact-us/business)
   - `Payment icon` - it is possible to add an icon to the payment selection list
3. The data entered must be saved.
   
`*` Data can be obtained by going through the wizard in [merchant's panel](https://fx.conotoxia.com/merchant/).  

### Configuration of additional pages in PrestaShop
In order to redirect the customer to the store after the payment is completed and to receive notifications from the Conotoxia Pay system, you need to configure additional pages in the PrestaShop administration panel:  
1. Go to `Configure ->  Preferences -> Traffic`
2. Select `Add new page` in order to add a page to which the customer will be redirected after the payment is completed:
   - `Page name` - choose `conotoxiapay - success`
   - `URL` - e.g. `success`. he indicated address is necessary to also enter in the address configuration at the point of sale
3. The data entered should be saved.
4. It is necessary to add a second page in order to receive notifications from the Conotoxia Pay system:
   - `Page name` - choose `conotoxiapay - notification`
   - `URL` - e.g. `notification`. The indicated address is necessary to be entered also in the address configuration at the point of sale.
5. The data entered should be saved.

### Point of sale configuration in [merchant's panel](https://fx.conotoxia.com/merchant)
The point of sale should be configured in the merchant's panel based on the configuration carried out in `Configuration of additional pages in PrestaShop`:
- `URL address for payment creation notification` - e.g. https://presta.store.pl/notification
- `URL address for refund creation notification` - e.g. https://presta.store.pl/notification
- `URL address for successfully executed payment` - e.g. https://presta.store.pl/success
- `URL address for unsuccessful payment` - e.g. https://presta.store.pl/success

The addresses configured in the merchant panel and PrestaShop must be identical.

## Refunds
The Conotoxia Pay plugin provides its own solution for creating refunds. It does not require activation in PrestaShop. Refunds can be created from the details of a payment executed with ConotoxiaPay.

From the store level, you can make one full or several partial refunds for each payment.